VERSION 5.00
Begin VB.Form Main 
   BorderStyle     =   0  '
   Caption         =   "Sen's Sokoban"
   ClientHeight    =   6135
   ClientLeft      =   1575
   ClientTop       =   1635
   ClientWidth     =   8580
   LinkTopic       =   "1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "1.frx":0000
   ScaleHeight     =   409
   ScaleMode       =   3  '
   ScaleWidth      =   572
   ShowInTaskbar   =   0   'False
   Begin VB.Timer keytimer 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   480
      Top             =   6000
   End
   Begin VB.PictureBox menu 
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  '
      Height          =   5655
      Left            =   120
      ScaleHeight     =   377
      ScaleMode       =   3  '
      ScaleWidth      =   554
      TabIndex        =   2
      Top             =   300
      Width           =   8310
      Begin VB.CommandButton menuStart 
         Caption         =   "  "
         Height          =   375
         Left            =   2100
         TabIndex        =   4
         Top             =   4800
         Width           =   4095
      End
      Begin VB.PictureBox 1 
         AutoSize        =   -1  'True
         BorderStyle     =   0  '
         Height          =   2535
         Left            =   1380
         Picture         =   "1.frx":24AB
         ScaleHeight     =   2535
         ScaleWidth      =   5835
         TabIndex        =   3
         Top             =   180
         Width           =   5835
         Begin VB.Label version 
            AutoSize        =   -1  'True
            BackStyle       =   0  '
            Caption         =   "Version"
            BeginProperty Font 
               Name            =   "Tahoma"
               Size            =   8.25
               Charset         =   204
               Weight          =   400
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            ForeColor       =   &H00FFFFFF&
            Height          =   195
            Left            =   660
            TabIndex        =   5
            Top             =   420
            Width           =   525
         End
      End
      Begin VB.Label 2 
         BackStyle       =   0  '
         Caption         =   $"1.frx":5162
         ForeColor       =   &H00FFFFFF&
         Height          =   1035
         Left            =   2400
         TabIndex        =   7
         Top             =   3120
         Width           =   3555
      End
      Begin VB.Label 1 
         AutoSize        =   -1  'True
         BackStyle       =   0  '
         Caption         =   "WWW.ISHODNIKI.NAROD.RU"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   14.25
            Charset         =   204
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FFFFFF&
         Height          =   345
         Left            =   1980
         TabIndex        =   6
         Top             =   5340
         Width           =   4320
      End
   End
   Begin VB.PictureBox PlayScreen 
      AutoRedraw      =   -1  'True
      BackColor       =   &H008080FF&
      BorderStyle     =   0  '
      Height          =   5580
      Left            =   180
      ScaleHeight     =   372
      ScaleMode       =   3  '
      ScaleWidth      =   544
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   8160
   End
   Begin VB.Label Label_DvigatFormu 
      BackStyle       =   0  '
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   8535
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SOKOBAN
' Copyright (c) Sen, ded_mazay@rambler.ru
' ===================================
'
' :       
'      
'  .    ,  
'   - 3D Sokoban,  
'    .
'
' :
' !  DIRECTX 7.0A 
'  . 
'   PICCLP32.OCX  Windows\System

'    VB.  
'    ()   PROJECT1.VBP

'    :
' 1.   DirectX
'              
'               
'        
' 2. FoxCBmp.DLL
'         VB    
'        . WinAPI   .
' 3.    ...
'         ,    VB6 
' 4.   MAPS.TXT  "A"
'            ,   
'         -  ,  
'       .

'=================================================
'  ,    :
' 1.      ,  .....   !





Private mykey As Integer
Private dark_level As Integer
Dim DS As DirectSound
Const NUMSHIPHIT = 2
Const NUMSTEPS = 4
Dim ShipHit(NUMSHIPHIT - 1) As DirectSoundBuffer
Dim StepWav(3) As DirectSoundBuffer
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)


If PlayScreen.Visible = True And PlayScreen.Enabled = True Then PlayScreen_KeyUp KeyCode, Shift


End Sub

Private Sub Form_Load()
Main.Visible = True
dark_level = 0
Main.version.Caption = " " & App.Major & "." & App.Minor & App.Revision
CreateFonForScreen
CanPress = True
Dim DX As New DirectX7
Set DS = DX.DirectSoundCreate("")
DS.SetCooperativeLevel Me.hwnd, DSSCL_PRIORITY
Dim bufferDesc As DSBUFFERDESC
Dim waveFormat As WAVEFORMATEX
bufferDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
waveFormat.nFormatTag = WAVE_FORMAT_PCM
waveFormat.nChannels = 2
waveFormat.lSamplesPerSec = 22050
waveFormat.nBitsPerSample = 16
waveFormat.nBlockAlign = waveFormat.nBitsPerSample / 8 * waveFormat.nChannels
waveFormat.lAvgBytesPerSec = waveFormat.lSamplesPerSec * waveFormat.nBlockAlign
Set ShipHit(0) = DS.CreateSoundBufferFromFile("sound\pushbox1.wav", bufferDesc, waveFormat)
Set ShipHit(1) = DS.CreateSoundBufferFromFile("sound\pushbox2.wav", bufferDesc, waveFormat)
Set StepWav(0) = DS.CreateSoundBufferFromFile("sound\move1.wav", bufferDesc, waveFormat)
Set StepWav(1) = DS.CreateSoundBufferFromFile("sound\move2.wav", bufferDesc, waveFormat)
Set StepWav(2) = DS.CreateSoundBufferFromFile("sound\move3.wav", bufferDesc, waveFormat)
Set StepWav(3) = DS.CreateSoundBufferFromFile("sound\move4.wav", bufferDesc, waveFormat)
End Sub
Public Sub PlayMoveBox()
Dim i As Long
Dim C As DSCURSORS
For i = 0 To NUMSHIPHIT - 1
ShipHit(i).GetCurrentPosition C
If C.lPlay = 0 Then ShipHit(i).Play DSBPLAY_DEFAULT: Exit For
Next i
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
   Call CloseMidi
   Call UnHook
End

End Sub

Private Sub keytimer_Timer()
KeyCode = mykey
Dim tmp1 As Boolean
Sector = MyPos


If KeyCode = vbKeyLeft Then
  result = TryMove(3, MyPos)
End If

If KeyCode = vbKeyRight Then
  result = TryMove(4, MyPos)
End If

If KeyCode = vbKeyUp Then
  result = TryMove(1, MyPos)
End If

If KeyCode = vbKeyDown Then
  result = TryMove(2, MyPos)
End If

ScanForWin
CanPress = False



End Sub

Private Sub Label_DvigatFormu_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Call ReleaseCapture
Call SendMessage(Me.hwnd, WM_NCLBUTTONDOWN, HTCAPTION, 0&)
End Sub

Private Sub menuStart_Click()

PlayScreen.Visible = True
menu.Visible = False
LoadMapToMemory
LoadMapToScreen

'

End Sub

Private Sub PlayScreen_KeyDown(KeyCode As Integer, Shift As Integer)
mykey = KeyCode
keytimer.Enabled = True
End Sub

Private Sub PlayScreen_KeyUp(KeyCode As Integer, Shift As Integer)
If keytimer.Enabled = True Then
keytimer.Enabled = False
Exit Sub
End If



End Sub



Public Sub ReleaseMove(Sector, side)

End Sub


Public Sub PlayPlayerSteps()
Dim i As Long
Dim C As DSCURSORS

Randomize Timer
i = Int(Rnd * 3)
StepWav(i).GetCurrentPosition C
If C.lPlay = 0 Then StepWav(i).Play DSBPLAY_DEFAULT: Exit Sub



End Sub

Private Sub 1_Click()
Form_QueryUnload
End Sub

Private Sub 2_Click()
PlayScreen_KeyUp vbKeyDown, 0
End Sub

Private Sub 3_Click()
PlayScreen_KeyUp vbKeyLeft, 0
End Sub

Private Sub 4_Click()
PlayScreen_KeyUp vbKeyRight, 0
End Sub

Private Sub 5_Click()
End
End Sub

